'use strict';

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _extends = require('babel-runtime/helpers/extends')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Const = require('./Const');

var _Const2 = _interopRequireDefault(_Const);

var TableColumn = (function (_Component) {
  _inherits(TableColumn, _Component);

  function TableColumn(props) {
    var _this = this;

    _classCallCheck(this, TableColumn);

    _Component.call(this, props);

    this.handleCellEdit = function (e) {
      if (_this.props.cellEdit.mode === _Const2['default'].CELL_EDIT_DBCLICK) {
        if (document.selection && document.selection.empty) {
          document.selection.empty();
        } else if (window.getSelection) {
          var sel = window.getSelection();
          sel.removeAllRanges();
        }
      }
      _this.props.onEdit(e.currentTarget.parentElement.rowIndex + 1, e.currentTarget.cellIndex);
    };
  }

  /* eslint no-unused-vars: [0, { "args": "after-used" }] */

  TableColumn.prototype.shouldComponentUpdate = function shouldComponentUpdate(nextProps, nextState) {
    var children = this.props.children;

    var shouldUpdated = this.props.width !== nextProps.width || this.props.className !== nextProps.className || this.props.hidden !== nextProps.hidden || this.props.dataAlign !== nextProps.dataAlign || typeof children !== typeof nextProps.children || ('' + this.props.onEdit).toString() !== ('' + nextProps.onEdit).toString();

    if (shouldUpdated) {
      return shouldUpdated;
    }

    if (typeof children === 'object' && children !== null && children.props !== null) {
      if (children.props.type === 'checkbox' || children.props.type === 'radio') {
        shouldUpdated = shouldUpdated || children.props.type !== nextProps.children.props.type || children.props.checked !== nextProps.children.props.checked;
      } else {
        shouldUpdated = true;
      }
    } else {
      shouldUpdated = shouldUpdated || children !== nextProps.children;
    }

    if (shouldUpdated) {
      return shouldUpdated;
    }

    if (!(this.props.cellEdit && nextProps.cellEdit)) {
      return false;
    } else {
      return shouldUpdated || this.props.cellEdit.mode !== nextProps.cellEdit.mode;
    }
  };

  TableColumn.prototype.render = function render() {
    var tdStyle = {
      textAlign: this.props.dataAlign,
      display: this.props.hidden ? 'none' : null
    };

    var opts = {};
    if (this.props.cellEdit) {
      if (this.props.cellEdit.mode === _Const2['default'].CELL_EDIT_CLICK) {
        opts.onClick = this.handleCellEdit;
      } else if (this.props.cellEdit.mode === _Const2['default'].CELL_EDIT_DBCLICK) {
        opts.onDoubleClick = this.handleCellEdit;
      }
    }
    return _react2['default'].createElement(
      'td',
      _extends({ style: tdStyle, className: this.props.className }, opts),
      this.props.children
    );
  };

  return TableColumn;
})(_react.Component);

TableColumn.propTypes = {
  dataAlign: _react.PropTypes.string,
  hidden: _react.PropTypes.bool,
  className: _react.PropTypes.string,
  children: _react.PropTypes.node
};

TableColumn.defaultProps = {
  dataAlign: 'left',
  hidden: false,
  className: ''
};
exports['default'] = TableColumn;
module.exports = exports['default'];