'use strict';

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Const = require('./Const');

var _Const2 = _interopRequireDefault(_Const);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var TableFilter = (function (_Component) {
  _inherits(TableFilter, _Component);

  function TableFilter(props) {
    var _this = this;

    _classCallCheck(this, TableFilter);

    _Component.call(this, props);

    this.handleKeyUp = function (e) {
      var _e$currentTarget = e.currentTarget;
      var value = _e$currentTarget.value;
      var name = _e$currentTarget.name;

      if (value.trim() === '') {
        delete _this.filterObj[name];
      } else {
        _this.filterObj[name] = value;
      }
      _this.props.onFilter(_this.filterObj);
    };

    this.filterObj = {};
  }

  TableFilter.prototype.render = function render() {
    var _props = this.props;
    var striped = _props.striped;
    var condensed = _props.condensed;
    var rowSelectType = _props.rowSelectType;
    var columns = _props.columns;

    var tableClasses = _classnames2['default']('table', {
      'table-striped': striped,
      'table-condensed': condensed
    });
    var selectRowHeader = null;

    if (rowSelectType === _Const2['default'].ROW_SELECT_SINGLE || rowSelectType === _Const2['default'].ROW_SELECT_MULTI) {
      var style = {
        width: 35,
        paddingLeft: 0,
        paddingRight: 0
      };
      selectRowHeader = _react2['default'].createElement(
        'th',
        { style: style, key: -1 },
        'Filter'
      );
    }

    var filterField = columns.map(function (column) {
      var hidden = column.hidden;
      var width = column.width;
      var name = column.name;

      var thStyle = {
        display: hidden ? 'none' : null,
        width: width
      };
      return _react2['default'].createElement(
        'th',
        { key: name, style: thStyle },
        _react2['default'].createElement(
          'div',
          { className: 'th-inner table-header-column' },
          _react2['default'].createElement('input', { size: '10', type: 'text',
            placeholder: name, name: name, onKeyUp: this.handleKeyUp })
        )
      );
    }, this);

    return _react2['default'].createElement(
      'table',
      { className: tableClasses, style: { marginTop: 5 } },
      _react2['default'].createElement(
        'thead',
        null,
        _react2['default'].createElement(
          'tr',
          { style: { borderBottomStyle: 'hidden' } },
          selectRowHeader,
          filterField
        )
      )
    );
  };

  return TableFilter;
})(_react.Component);

TableFilter.propTypes = {
  columns: _react.PropTypes.array,
  rowSelectType: _react.PropTypes.string,
  onFilter: _react.PropTypes.func
};
exports['default'] = TableFilter;
module.exports = exports['default'];