/* eslint default-case: 0 */
/* eslint guard-for-in: 0 */
'use strict';

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _extends = require('babel-runtime/helpers/extends')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Const = require('./Const');

var _Const2 = _interopRequireDefault(_Const);

var _filtersDate = require('./filters/Date');

var _filtersDate2 = _interopRequireDefault(_filtersDate);

var _filtersText = require('./filters/Text');

var _filtersText2 = _interopRequireDefault(_filtersText);

var _filtersRegex = require('./filters/Regex');

var _filtersRegex2 = _interopRequireDefault(_filtersRegex);

var _filtersSelect = require('./filters/Select');

var _filtersSelect2 = _interopRequireDefault(_filtersSelect);

var _filtersNumber = require('./filters/Number');

var _filtersNumber2 = _interopRequireDefault(_filtersNumber);

var TableHeaderColumn = (function (_Component) {
  _inherits(TableHeaderColumn, _Component);

  function TableHeaderColumn(props) {
    var _this = this;

    _classCallCheck(this, TableHeaderColumn);

    _Component.call(this, props);

    this.handleColumnClick = function () {
      if (!_this.props.dataSort) return;
      var order = _this.props.sort === _Const2['default'].SORT_DESC ? _Const2['default'].SORT_ASC : _Const2['default'].SORT_DESC;
      _this.props.onSort(order, _this.props.dataField);
    };

    this.handleFilter = this.handleFilter.bind(this);
  }

  TableHeaderColumn.prototype.handleFilter = function handleFilter(value, type) {
    this.props.filter.emitter.handleFilter(this.props.dataField, value, type);
  };

  TableHeaderColumn.prototype.getFilters = function getFilters() {
    switch (this.props.filter.type) {
      case _Const2['default'].FILTER_TYPE.TEXT:
        {
          return _react2['default'].createElement(_filtersText2['default'], _extends({}, this.props.filter, {
            columnName: this.props.children, filterHandler: this.handleFilter }));
        }
      case _Const2['default'].FILTER_TYPE.REGEX:
        {
          return _react2['default'].createElement(_filtersRegex2['default'], _extends({}, this.props.filter, {
            columnName: this.props.children, filterHandler: this.handleFilter }));
        }
      case _Const2['default'].FILTER_TYPE.SELECT:
        {
          return _react2['default'].createElement(_filtersSelect2['default'], _extends({}, this.props.filter, {
            columnName: this.props.children, filterHandler: this.handleFilter }));
        }
      case _Const2['default'].FILTER_TYPE.NUMBER:
        {
          return _react2['default'].createElement(_filtersNumber2['default'], _extends({}, this.props.filter, {
            columnName: this.props.children, filterHandler: this.handleFilter }));
        }
      case _Const2['default'].FILTER_TYPE.DATE:
        {
          return _react2['default'].createElement(_filtersDate2['default'], _extends({}, this.props.filter, {
            columnName: this.props.children, filterHandler: this.handleFilter }));
        }
      case _Const2['default'].FILTER_TYPE.CUSTOM:
        {
          return this.props.filter.getElement(this.handleFilter, this.props.filter.customFilterParameters);
        }
    }
  };

  TableHeaderColumn.prototype.componentDidMount = function componentDidMount() {
    this.refs['header-col'].setAttribute('data-field', this.props.dataField);
  };

  TableHeaderColumn.prototype.render = function render() {
    var defaultCaret = undefined;
    var thStyle = {
      textAlign: this.props.dataAlign,
      display: this.props.hidden ? 'none' : null
    };
    if (this.props.sortIndicator) {
      defaultCaret = !this.props.dataSort ? null : _react2['default'].createElement(
        'span',
        { className: 'order' },
        _react2['default'].createElement(
          'span',
          { className: 'dropdown' },
          _react2['default'].createElement('span', { className: 'caret' })
        ),
        _react2['default'].createElement(
          'span',
          { className: 'dropup' },
          _react2['default'].createElement('span', { className: 'caret' })
        )
      );
    }
    var sortCaret = undefined;
    if (this.props.caretRender) {
      sortCaret = this.props.caretRender(this.props.sort);
    } else {
      sortCaret = this.props.sort ? this.renderSortCaret(this.props.sort) : defaultCaret;
    }

    var classes = this.props.className + ' ' + (this.props.dataSort ? 'sort-column' : '');
    var title = typeof this.props.children === 'string' ? { title: this.props.children } : null;
    return _react2['default'].createElement(
      'th',
      _extends({ ref: 'header-col',
        className: classes,
        style: thStyle,
        onClick: this.handleColumnClick
      }, title),
      this.props.children,
      sortCaret,
      _react2['default'].createElement(
        'div',
        { onClick: function (e) {
            return e.stopPropagation();
          } },
        this.props.filter ? this.getFilters() : null
      )
    );
  };

  TableHeaderColumn.prototype.renderSortCaret = function renderSortCaret(order) {
    var orderClass = _classnames2['default']('order', {
      'dropup': order === _Const2['default'].SORT_ASC
    });
    return _react2['default'].createElement(
      'span',
      { className: orderClass },
      _react2['default'].createElement('span', { className: 'caret' })
    );
  };

  return TableHeaderColumn;
})(_react.Component);

var filterTypeArray = [];
for (var key in _Const2['default'].FILTER_TYPE) {
  filterTypeArray.push(_Const2['default'].FILTER_TYPE[key]);
}

TableHeaderColumn.propTypes = {
  dataField: _react.PropTypes.string,
  dataAlign: _react.PropTypes.string,
  dataSort: _react.PropTypes.bool,
  onSort: _react.PropTypes.func,
  dataFormat: _react.PropTypes.func,
  isKey: _react.PropTypes.bool,
  editable: _react.PropTypes.any,
  hidden: _react.PropTypes.bool,
  searchable: _react.PropTypes.bool,
  className: _react.PropTypes.string,
  width: _react.PropTypes.string,
  sortFunc: _react.PropTypes.func,
  sortFuncExtraData: _react.PropTypes.any,
  columnClassName: _react.PropTypes.any,
  filterFormatted: _react.PropTypes.bool,
  sort: _react.PropTypes.string,
  caretRender: _react.PropTypes.func,
  formatExtraData: _react.PropTypes.any,
  filter: _react.PropTypes.shape({
    type: _react.PropTypes.oneOf(filterTypeArray),
    delay: _react.PropTypes.number,
    options: _react.PropTypes.oneOfType([_react.PropTypes.object, // for SelectFilter
    _react.PropTypes.arrayOf(_react.PropTypes.number) // for NumberFilter
    ]),
    numberComparators: _react.PropTypes.arrayOf(_react.PropTypes.string),
    emitter: _react.PropTypes.object,
    placeholder: _react.PropTypes.string,
    getElement: _react.PropTypes.func,
    customFilterParameters: _react.PropTypes.object
  }),
  sortIndicator: _react.PropTypes.bool
};

TableHeaderColumn.defaultProps = {
  dataAlign: 'left',
  dataSort: false,
  dataFormat: undefined,
  isKey: false,
  editable: true,
  onSort: undefined,
  hidden: false,
  searchable: true,
  className: '',
  width: null,
  sortFunc: undefined,
  columnClassName: '',
  filterFormatted: false,
  sort: undefined,
  formatExtraData: undefined,
  sortFuncExtraData: undefined,
  filter: undefined,
  sortIndicator: true
};

exports['default'] = TableHeaderColumn;
module.exports = exports['default'];