/* eslint quotes: 0 */
/* eslint max-len: 0 */
'use strict';

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Const = require('../Const');

var _Const2 = _interopRequireDefault(_Const);

var DateFilter = (function (_Component) {
  _inherits(DateFilter, _Component);

  function DateFilter(props) {
    _classCallCheck(this, DateFilter);

    _Component.call(this, props);
    this.filter = this.filter.bind(this);
  }

  DateFilter.prototype.setDefaultDate = function setDefaultDate() {
    var defaultDate = '';
    if (this.props.defaultValue) {
      // Set the appropriate format for the input type=date, i.e. "YYYY-MM-DD"
      var defaultValue = new Date(this.props.defaultValue);
      defaultDate = defaultValue.getFullYear() + '-' + ("0" + (defaultValue.getMonth() + 1)).slice(-2) + '-' + ("0" + defaultValue.getDate()).slice(-2);
    }
    return defaultDate;
  };

  DateFilter.prototype.filter = function filter(event) {
    var dateValue = event.target.value;
    if (dateValue) {
      this.props.filterHandler(new Date(dateValue), _Const2['default'].FILTER_TYPE.DATE);
    } else {
      this.props.filterHandler(null, _Const2['default'].FILTER_TYPE.DATE);
    }
  };

  DateFilter.prototype.componentDidMount = function componentDidMount() {
    var dateValue = this.refs.inputDate.defaultValue;
    if (dateValue) {
      this.props.filterHandler(new Date(dateValue), _Const2['default'].FILTER_TYPE.DATE);
    }
  };

  DateFilter.prototype.render = function render() {
    return _react2['default'].createElement('input', { ref: 'inputDate',
      className: 'filter date-filter form-control',
      type: 'date',
      onChange: this.filter,
      defaultValue: this.setDefaultDate() });
  };

  return DateFilter;
})(_react.Component);

DateFilter.propTypes = {
  filterHandler: _react.PropTypes.func.isRequired,
  defaultValue: _react.PropTypes.object,
  columnName: _react.PropTypes.string
};

exports['default'] = DateFilter;
module.exports = exports['default'];