'use strict';

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

exports.__esModule = true;

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _utilsBootstrapUtils = require('./utils/bootstrapUtils');

var _utilsBootstrapUtils2 = _interopRequireDefault(_utilsBootstrapUtils);

var Tip = _react2['default'].createClass({
  displayName: 'Tip',

  getInitialState: function getInitialState() {
    return {
      marginTop: 0,
      marginLeft: 0
    };
  },
  render: function render() {
    var tipClass = "msg-tips-pop tips-" + this.props.status;

    return _react2['default'].createElement(
      'div',
      { className: tipClass, ref: 'topTip' },
      _react2['default'].createElement(
        'div',
        { className: 'tips-content' },
        this.props.children
      )
    );
  },
  componentDidMount: function componentDidMount() {
    var node = _reactDom2['default'].findDOMNode(this.refs.topTip);
    node.style.marginLeft = -node.clientWidth / 2;
    node.style.marginTop = -node.clientHeight / 2;

    // 如果存在定时器则执行  	
    if (this.props.timeout && this.props.onDismiss) {
      this.dismissTimer = setTimeout(this.props.onDismiss, this.props.timeout);
    }
  },
  componentWillUnmount: function componentWillUnmount() {
    // 组件消失的时候，清空定时器
    clearTimeout(this.dismissTimer);
  }
});

Tip.propTypes = {
  /**
   * status 
   * 
   */
  status: _react2['default'].PropTypes.oneOf(['error', 'success']),
  /**
   * 消失执行
   * 
   */
  onDismiss: _react2['default'].PropTypes.func,
  /**
   * 延时消失
   * 
   */
  timeout: _react2['default'].PropTypes.number
};
Tip.defaultProps = {
  status: 'success',
  timeout: 5000

};

exports['default'] = _utilsBootstrapUtils.bsClass('Tip', Tip);
module.exports = exports['default'];